# -*- coding: utf-8 -*-
from setuphelpers import *

# https://forums.pdfforge.org/t/echec-mise-a-jour-pdf-creator-en-ligne-de-commande/13553/4
# {0001B4FD-9EA3-4D90-A79E-FD14BA3AB01D}     PDFCreator  3.2.0   C:\Program Files\PDFCreator\unins000.exe

def install():
    # Uninstalling other versions of the software
    for to_uninstall in installed_softwares(name="^PDFCreator$"):
        if Version(to_uninstall["version"]) != Version(control.get_software_version()) or force:
            print("Removing: %s (%s)" % (to_uninstall["name"], to_uninstall["version"]))
            try:
                killalltasks(control.get_impacted_process_list())
                run(uninstall_cmd(to_uninstall["key"]))
                wait_uninstallkey_absent(to_uninstall["key"])
            except Exception as e:
                print(e)
                print("Remove failed: %s (%s)\nContinuing..." % (to_uninstall["name"], to_uninstall["version"]))

    # Installing the package
    install_exe_if_needed(
        "PDFCreator-3_2_0-Setup.exe",
        silentflags='/VERYSILENT /NORESTART /LOADINF="install_options"',
        key="{0001B4FD-9EA3-4D90-A79E-FD14BA3AB01D}",
        min_version=control.get_software_version(),
    )


#     uninstallkey.clear()


# def uninstall():
#     silent_uninst_args = "/VERYSILENT /NORESTART"
#     uninst_path_x64 = makepath(programfiles, "PDFCreator", "unins001.exe")
#     uninst_path_x86 = makepath(programfiles, "PDFCreator", "unins000.exe")

#     if isfile(makepath(programfiles, "PDFCreator", "unins001.dat")):
#         run('"%s" %s' % (uninst_path_x64, silent_uninst_args))
#     else:
#         run('"%s" %s' % (uninst_path_x86, silent_uninst_args))


def session_setup():
    print("Disabling: automatic updates")
    registry_setstring(HKEY_CURRENT_USER, r"Software\pdfforge\PDFCreator\Settings\ApplicationSettings", "UpdateInterval", "Never")
    registry_setstring(HKEY_CURRENT_USER, r"Software\pdfforge\PDFCreator", "SkipVersion", "3.5.0")
